function [residual, g1, g2, g3] = NK_CGG02_impinf4_dynamic(y, x, params, steady_state, it_)
%
% Status : Computes dynamic model for Dynare
%
% Inputs :
%   y         [#dynamic variables by 1] double    vector of endogenous variables in the order stored
%                                                 in M_.lead_lag_incidence; see the Manual
%   x         [nperiods by M_.exo_nbr] double     matrix of exogenous variables (in declaration order)
%                                                 for all simulation periods
%   steady_state  [M_.endo_nbr by 1] double       vector of steady state values
%   params    [M_.param_nbr by 1] double          vector of parameter values in declaration order
%   it_       scalar double                       time period for exogenous variables for which to evaluate the model
%
% Outputs:
%   residual  [M_.endo_nbr by 1] double    vector of residuals of the dynamic model equations in order of 
%                                          declaration of the equations.
%                                          Dynare may prepend auxiliary equations, see M_.aux_vars
%   g1        [M_.endo_nbr by #dynamic variables] double    Jacobian matrix of the dynamic model equations;
%                                                           rows: equations in order of declaration
%                                                           columns: variables in order stored in M_.lead_lag_incidence followed by the ones in M_.exo_names
%   g2        [M_.endo_nbr by (#dynamic variables)^2] double   Hessian matrix of the dynamic model equations;
%                                                              rows: equations in order of declaration
%                                                              columns: variables in order stored in M_.lead_lag_incidence followed by the ones in M_.exo_names
%   g3        [M_.endo_nbr by (#dynamic variables)^3] double   Third order derivative matrix of the dynamic model equations;
%                                                              rows: equations in order of declaration
%                                                              columns: variables in order stored in M_.lead_lag_incidence followed by the ones in M_.exo_names
%
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(22, 1);
lhs =y(11);
rhs =y(33)-1/params(1)*(y(16)-y(36)-y(14));
residual(1)= lhs-rhs;
lhs =y(14);
rhs =params(1)*(y(34)-y(12))+params(5)*(y(39)-y(24));
residual(2)= lhs-rhs;
lhs =y(12);
rhs =1/params(7)*((1+params(8))*y(19)-params(5)*y(24));
residual(3)= lhs-rhs;
lhs =y(11);
rhs =y(13)-y(12);
residual(4)= lhs-rhs;
lhs =y(15);
rhs =y(36)*params(2)+y(11)*params(3)+y(18);
residual(5)= lhs-rhs;
lhs =y(16);
rhs =params(13)*y(1)+(1-params(13))*(y(14)+y(21)+params(15)*(y(15)-y(21))+y(11)*params(16))+y(20);
residual(6)= lhs-rhs;
lhs =y(17);
rhs =y(16)-y(36);
residual(7)= lhs-rhs;
lhs =y(18);
rhs =params(11)*y(2)+x(it_, 1);
residual(8)= lhs-rhs;
lhs =y(19);
rhs =params(12)*y(3)+x(it_, 2);
residual(9)= lhs-rhs;
lhs =y(21);
rhs =(1-params(17))*params(18)+params(17)*y(5)+x(it_, 4);
residual(10)= lhs-rhs;
lhs =y(20);
rhs =params(14)*y(4)+x(it_, 3);
residual(11)= lhs-rhs;
lhs =y(22);
rhs =y(37)-1/params(21)*(y(27)-y(40)-y(25));
residual(12)= lhs-rhs;
lhs =y(25);
rhs =params(21)*(y(38)-y(23))+params(25)*(y(35)-y(13));
residual(13)= lhs-rhs;
lhs =y(23);
rhs =1/params(27)*((1+params(28))*y(30)-y(13)*params(25));
residual(14)= lhs-rhs;
lhs =y(22);
rhs =y(24)-y(23);
residual(15)= lhs-rhs;
lhs =y(26);
rhs =y(40)*params(22)+y(22)*params(23)+y(29);
residual(16)= lhs-rhs;
lhs =y(27);
rhs =params(32)*y(6)+(1-params(32))*(y(25)+y(32)+params(34)*(y(26)-y(32))+y(22)*params(35))+y(31);
residual(17)= lhs-rhs;
lhs =y(28);
rhs =y(27)-y(40);
residual(18)= lhs-rhs;
lhs =y(29);
rhs =params(30)*y(7)+x(it_, 5);
residual(19)= lhs-rhs;
lhs =y(30);
rhs =params(31)*y(8)+x(it_, 6);
residual(20)= lhs-rhs;
lhs =y(32);
rhs =(1-params(36))*params(37)+params(36)*y(10)+x(it_, 8);
residual(21)= lhs-rhs;
lhs =y(31);
rhs =params(33)*y(9)+x(it_, 7);
residual(22)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(22, 48);

  %
  % Jacobian matrix
  %

  g1(1,11)=1;
  g1(1,33)=(-1);
  g1(1,14)=(-(1/params(1)));
  g1(1,36)=(-(1/params(1)));
  g1(1,16)=1/params(1);
  g1(2,12)=params(1);
  g1(2,34)=(-params(1));
  g1(2,14)=1;
  g1(2,24)=params(5);
  g1(2,39)=(-params(5));
  g1(3,12)=1;
  g1(3,19)=(-(1/params(7)*(1+params(8))));
  g1(3,24)=(-(1/params(7)*(-params(5))));
  g1(4,11)=1;
  g1(4,12)=1;
  g1(4,13)=(-1);
  g1(5,11)=(-params(3));
  g1(5,15)=1;
  g1(5,36)=(-params(2));
  g1(5,18)=(-1);
  g1(6,11)=(-((1-params(13))*params(16)));
  g1(6,14)=(-(1-params(13)));
  g1(6,15)=(-((1-params(13))*params(15)));
  g1(6,1)=(-params(13));
  g1(6,16)=1;
  g1(6,20)=(-1);
  g1(6,21)=(-((1-params(13))*(1-params(15))));
  g1(7,36)=1;
  g1(7,16)=(-1);
  g1(7,17)=1;
  g1(8,2)=(-params(11));
  g1(8,18)=1;
  g1(8,41)=(-1);
  g1(9,3)=(-params(12));
  g1(9,19)=1;
  g1(9,42)=(-1);
  g1(10,5)=(-params(17));
  g1(10,21)=1;
  g1(10,44)=(-1);
  g1(11,4)=(-params(14));
  g1(11,20)=1;
  g1(11,43)=(-1);
  g1(12,22)=1;
  g1(12,37)=(-1);
  g1(12,25)=(-(1/params(21)));
  g1(12,40)=(-(1/params(21)));
  g1(12,27)=1/params(21);
  g1(13,13)=params(25);
  g1(13,35)=(-params(25));
  g1(13,23)=params(21);
  g1(13,38)=(-params(21));
  g1(13,25)=1;
  g1(14,13)=(-(1/params(27)*(-params(25))));
  g1(14,23)=1;
  g1(14,30)=(-(1/params(27)*(1+params(28))));
  g1(15,22)=1;
  g1(15,23)=1;
  g1(15,24)=(-1);
  g1(16,22)=(-params(23));
  g1(16,26)=1;
  g1(16,40)=(-params(22));
  g1(16,29)=(-1);
  g1(17,22)=(-((1-params(32))*params(35)));
  g1(17,25)=(-(1-params(32)));
  g1(17,26)=(-((1-params(32))*params(34)));
  g1(17,6)=(-params(32));
  g1(17,27)=1;
  g1(17,31)=(-1);
  g1(17,32)=(-((1-params(32))*(1-params(34))));
  g1(18,40)=1;
  g1(18,27)=(-1);
  g1(18,28)=1;
  g1(19,7)=(-params(30));
  g1(19,29)=1;
  g1(19,45)=(-1);
  g1(20,8)=(-params(31));
  g1(20,30)=1;
  g1(20,46)=(-1);
  g1(21,10)=(-params(36));
  g1(21,32)=1;
  g1(21,48)=(-1);
  g1(22,9)=(-params(33));
  g1(22,31)=1;
  g1(22,47)=(-1);

if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],22,2304);
if nargout >= 4,
  %
  % Third order derivatives
  %

  g3 = sparse([],[],[],22,110592);
end
end
end
end
